declare type Constructor<T> = {
    new (...args: any[]): T;
};
declare type ObjectWithName = {
    name: string;
};
declare type ProvidesConfig = {
    singleton?: boolean;
};
declare type Name = Symbol | string;
declare type NameLike<T = any> = ObjectWithName | Constructor<T> | Name;
export declare function adapter<T>(type: NameLike, config?: ProvidesConfig): (target: any) => void;
export declare function port<T>(type: NameLike): (target: any, propName: string) => void;
export declare function New<C extends Constructor<any>>(type: C, ...args: ConstructorParameters<C>): InstanceType<C>;
export declare class Container {
    static clear(): void;
    static resolve<T>(type: Constructor<T>, ...args: any[]): T;
    static resolve<T = never>(type: Name, ...args: any[]): T extends never ? never : T;
    static registerAs<T>(type: Constructor<T>, name: Name): void;
    static registerAs<T extends Z, Z>(type: Constructor<T>, inter: Constructor<Z>): void;
    static registerSingleton(instance: any, name: Name): any;
    static registerSingleton<T extends Z, Z>(instance: T, type: Constructor<Z>): any;
    static singleton<T, Z extends T = any>(type: Constructor<T>, impl?: Constructor<Z>): void;
    static register(...types: Constructor<any>[]): void;
}
export {};
//# sourceMappingURL=index.d.ts.map